/*
 * CDDL HEADER START
 *
 * The contents of this file are subject to the terms of the
 * Common Development and Distribution License (the "License").
 * You may not use this file except in compliance with the License.
 *
 * You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
 * or http://www.opensolaris.org/os/licensing.
 * See the License for the specific language governing permissions
 * and limitations under the License.
 *
 * When distributing Covered Code, include this CDDL HEADER in each
 * file and include the License file at usr/src/OPENSOLARIS.LICENSE.
 * If applicable, add the following below this CDDL HEADER, with the
 * fields enclosed by brackets "[]" replaced with your own identifying
 * information: Portions Copyright [yyyy] [name of copyright owner]
 *
 * CDDL HEADER END
 */

/*
 * Copyright 2015 Mohamed A. Khalfella <khalfella@gmail.com>
 */
#ifndef _SYS_PIDNODE_H
#define	_SYS_PIDNODE_H

#include <sys/list.h>

#ifdef	__cplusplus
extern "C" {
#endif

#define	CONN_PID_NODE_LIST_HDR_MAGIC	0x5A7A0B1D

#define	CONN_PID_NODE_LIST_HDR_NON	0
#define	CONN_PID_NODE_LIST_HDR_SOC	1
#define	CONN_PID_NODE_LIST_HDR_XTI	2
#define	CONN_PID_NODE_LIST_HDR_UNX	3

typedef struct conn_pid_node_s {
	uint32_t	cpn_pid;
} conn_pid_node_t;

typedef struct conn_pid_node_list_hdr_s {
	uint32_t	cph_magic;	/* CONN_PID_NODE_LIST_HDR_MAGIC */
	uint32_t	cph_contents;	/* CONN_PID_NODE_LIST_HDR_* */
	uint64_t	cph_pn_cnt;	/* # of conn_pid_node_t(s) */
	uint64_t	cph_tot_size;	/* total size of hdr + nodes */
	uint32_t	cph_flags;	/* not used yet */
	uint32_t	cph_optional1;  /* an optional field, not used yet */
	uint64_t	cph_optional2;  /* an optional field, not used yet */
	conn_pid_node_t	cph_cpns[1];	/* arrary of conn_pid_node_t */
} conn_pid_node_list_hdr_t;

#if defined(_KERNEL)

typedef struct pid_node_s {
	list_node_t	pn_ref_link;
	uint32_t	pn_count;
	uint32_t	pn_pid;
} pid_node_t;

#endif /* defined(_KERNEL) */

#define	PIDNODE2CONNPIDNODE(pn, cpn)	(cpn)->cpn_pid = (pn)->pn_pid

#ifdef	__cplusplus
}
#endif

#endif /* _SYS_PIDNODE_H */
